\chapter{Java Connectivity}\label{java-connectivity}

{\LARGE J}VM is the powering force behind ZoomBA.
This chapter illustrates various usage scenarios where ZoomBA can be
embedded inside a plain Java Program.

\begin{section}{How to Embed}

\begin{subsection}{Dependencies}
\index{maven}
In the dependency section (latest release is 0.2 ) : 
\begin{lstlisting}[style=XmlStyle]
<dependency>
  <groupId>org.zoomba-lang</groupId>
  <artifactId>zoomba.lang.core</artifactId>
   <version>0.1-beta5-SNAPSHOT</version>
</dependency>
\end{lstlisting}
That should immediately make your project a ZoomBA supported one.
\end{subsection}

\begin{subsection}{Programming Model}
\index{ java connectivity : programming model }
ZoomBA has a random access memory model.
The script interpreter is generally single threaded,
but each thread is given its own engine to avoid
the interpreter problem of \href{https://en.wikipedia.org/wiki/Global\_interpreter\_lock}{GIL}.

The memory comes in two varieties, default registers, which are used for global variables.
There is also this purely abstract 
\href{https://gitlab.com/non.est.sacra/zoomba/blob/master/src/main/java/zoomba/lang/core/interpreter/ZContext.java}{ZContext} type,
which abstracts how local storage gets used. This design makes  pretty neat to integrate with any other JVM language, specifically Java. 

Here is an example embedding.
\end{subsection}

\begin{subsection}{Example Embedding}
One sample embedding is furnished here :
\index{ java connectivity : sample embedding }


\begin{center}\begin{minipage}{\linewidth}
\begin{lstlisting}[style=myJavaStyle]
/* How to use ZoomBA Natively, i.e. not using JSR-232 */
import zoomba.lang.core.interpreter.ZContext;
import zoomba.lang.core.interpreter.ZContext.*;
import zoomba.lang.core.interpreter.ZInterpret;
import zoomba.lang.core.interpreter.ZScript;
import zoomba.lang.core.operations.Function;
import zoomba.lang.core.types.ZException;
import zoomba.lang.core.types.ZTypes;
//... can be more... 
public static void dance(String[] args) {
   String file = args[0];
   ZScript zs = null;
   try {
         zs = new ZScript(file, null);
   }catch (Throwable t){
       if ( t.getCause() instanceof ZException.Parsing ){
           ZException.Parsing p = (ZException.Parsing)t.getCause();
           System.err.printf("Parse Error: %s\n", p.errorMessage );
           System.err.printf("Options were : %s\n", ZTypes.string(p.correctionOptions) );
       }else{
           System.err.printf("Error in parsing due to : %s\n", t.getCause() );
       }
       System.exit(2);
    }
    Object[] scripArgs = ZTypes.shiftArgsLeft(args);
    Function.MonadicContainer mc = zs.execute(scripArgs);
    if (mc.isNil()) {
      // handle when return is ... Nil
    } else {
       if (mc.value() instanceof Throwable) {
           Throwable underlying = (Throwable) mc.value();
       if ( underlying instanceof ZException){
           if ( underlying instanceof ZException.ZTerminateException ){
                System.exit(3);
           }
           System.err.println(underlying);
           zs.consumeTrace(System.err::println);
           System.exit(4);
       }
       if ( underlying instanceof StackOverflowError ){
           zs.consumeTrace(System.err::println);
           System.err.println("---> Resulted in 'Stack OverFlow' Error!");
           System.exit(4);
       }
       underlying.printStackTrace();
       System.exit(1);
   }
  }
  System.exit(0);
}

\end{lstlisting}  
\end{minipage}\end{center}
\end{subsection}


\end{section}

\begin{section}{Programming ZoomBA}
Because it is JSR-223 compliant you can do this :

\begin{center}\begin{minipage}{\linewidth}
\begin{lstlisting}[style=myJavaStyle]
public void javaxScripting() throws Exception {
    ScriptEngineManager scriptEngineManager = new ScriptEngineManager();
    ScriptEngine engine = scriptEngineManager.getEngineByName("zoomba");
    assertNotNull(engine);
    Object result = engine.eval("2+2");
    assertEquals(4,result);
    Bindings bindings = engine.createBindings();
    bindings.put("x", 2 );
    bindings.put("y", 2 );
    result = engine.eval("x+y", bindings);
    assertEquals(4,result);
    ScriptContext scriptContext = engine.getContext();
    scriptContext.setAttribute("x", 2, ScriptContext.ENGINE_SCOPE );
    scriptContext.setAttribute("y", 2, ScriptContext.GLOBAL_SCOPE );
    result = engine.eval("x+y");
    assertEquals(4,result);
    CompiledScript compiledScript = ((Compilable)engine).compile("x+y");
    assertEquals( engine, compiledScript.getEngine());
    result = compiledScript.eval(bindings);
    assertEquals(4,result);
    // function invoke ?
    engine.eval("def add(a,b){ a + b }",scriptContext);
    result = ((Invocable)engine).invokeFunction("add", 2, 2);
    assertEquals(4,result);
    // method invoke ?
    Object zo = engine.eval(new StringReader("def ZO{ def add(a,b){ a + b } } ; new(ZO) ") ,scriptContext);
    assertNotNull(zo);
    assertTrue(zo instanceof ZObject);
    result = ((Invocable)engine).invokeMethod(zo,"add", 2, 2);
    assertEquals(4,result);
    // now attributes stuff
    assertEquals( 2, scriptContext.getScopes().size());
    assertNotNull(scriptContext.getAttribute("x"));
    final int scope = scriptContext.getAttributesScope("x");
    assertEquals(ScriptContext.ENGINE_SCOPE , scope);
    assertNotNull(scriptContext.getAttribute("y", ScriptContext.GLOBAL_SCOPE));
    scriptContext.removeAttribute("y", ScriptContext.GLOBAL_SCOPE);
    assertNull(scriptContext.getAttribute("y", ScriptContext.GLOBAL_SCOPE));
    assertNull(scriptContext.getAttribute("y"));
    assertEquals(-1, scriptContext.getAttributesScope("y"));
    // now let's eval a script... from external file
    zo = engine.eval("@samples/test/date.zm",scriptContext);
    assertNotNull(zo);
    compiledScript = ((Compilable)engine).compile("@samples/test/date.zm");
    assertNotNull(compiledScript);
    engine.put("y",10);
    assertEquals(10,engine.get("y"));
}
\end{lstlisting}  
\end{minipage}\end{center}


\end{section}

\begin{section}{Extending ZoomBA}

There are two extension points for Java developers
who are going to make their classes and functions ZoomBA ready.

\begin{subsection}{Implementing Named Arguments}
\index{ java connectivity : functions : named argument}

If one wants to implement a method which would mix properly with ZoomBA named arguments,
then one must accept a Java Map, whose keys are the name of the parameters while values are the values passed.

Thus, once we know that the argument is Map, we can extract the value, 
and do the due diligence.  Here is example from language itself:

\begin{center}\begin{minipage}{\linewidth}
\begin{lstlisting}[style=myJavaStyle]
\end{lstlisting}
\end{minipage}\end{center}


\end{subsection}


\begin{subsection}{Using Anonymous Arguments}
\index{ java connectivity : function : anonymous argument }

If one wants to implement the anonymous blocks like almost all the ZoomBA functions do,
one needs to expect the first argument to be an $AnonymousParam$ which is also found in the Interpreter.java.
The standard way to process the argument can be said as :

\begin{center}\begin{minipage}{\linewidth}
\begin{lstlisting}[style=myJavaStyle]
\end{lstlisting}
\end{minipage}\end{center}

\end{subsection}


\end{section}
